#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

//#include <openssl.h>
#include <gssapi.h>

#if (OPENSSL_VERSION_NUMBER >= 0x0090800fL)
#define SSLCONST const
#else
#define SSLCONST
#endif

gss_cred_id_t read_proxy(const char* filename) {
    gss_cred_id_t cred = NULL;
    OM_uint32 major_status;
    OM_uint32 minor_status;
    gss_buffer_desc proxy_filename;

    if(filename == NULL) return NULL;
    proxy_filename.value=malloc(strlen(filename)+32);
    strcpy((char*)proxy_filename.value,"X509_USER_PROXY=");
    strcat((char*)proxy_filename.value,filename);
    proxy_filename.length=strlen((char*)proxy_filename.value);
    major_status = gss_import_cred(&minor_status,
                                   &cred,
                                   NULL,
                                   1,
                                   &proxy_filename,
                                   GSS_C_INDEFINITE,
                                   NULL);
    if (major_status != GSS_S_COMPLETE) {
      cred=NULL;
    };
    free(proxy_filename.value);
    return cred;
}

void free_proxy(gss_cred_id_t cred) {
    OM_uint32 minor_status;
    if(cred == NULL) return;
    gss_release_cred(&minor_status,&cred);
}
